<template>
<div>
  <ul class="nav p-3" v-if="!id">
    <li class="nav-item">

      <div class="dropdown">
        <button class="btn btn-info dropdown-toggle" role="button" id="dropdownMenuLink" data-bs-toggle="dropdown" aria-expanded="false">
          Typ Statku powietrznego
        </button>

        <ul class="dropdown-menu" aria-labelledby="dropdownMenuLink">
          <li v-for="air_ship_type in airship_type_list" :key="air_ship_type.id">
            <input class="form-check-input" type="checkbox" v-model="air_ship_type.checkbox" v-bind:value="air_ship_type.id" id="flexCheckDefault" @change="(event) => SelectFilter(event, airship_type_selected_ids)">
            <label class="form-check-label" for="flexCheckDefault">
              {{air_ship_type.name}}
            </label>
           </li>
        </ul>
      </div>

    </li>
    <li class="nav-item">

      <div class="dropdown">
        <button class="btn btn-info dropdown-toggle" role="button" id="dropdownMenuLink" data-bs-toggle="dropdown" aria-expanded="false">
          Specjalizacja
        </button>

        <ul class="dropdown-menu" aria-labelledby="dropdownMenuLink">
          <li v-for="specialization in specialization_list" :key="specialization.id">
            <input class="form-check-input" type="checkbox" v-model="specialization.checkbox" v-bind:value="specialization.id" id="flexCheckDefault" @change="(event) => SelectFilter(event, specialization_selected_ids)">
            <label class="form-check-label" for="flexCheckDefault">
              {{specialization.name}}
            </label>
           </li>
        </ul>
      </div>

    </li>

    <li class="nav-item px-1">
      <button class="btn btn-dark" type="button" @click=ApplyFilters>
        Filtruj
      </button>
    </li>

    <li class="nav-item">
      <button class="btn btn-secondary" type="button" @click=ClearFilters>
        Wyczyść filtry
      </button>
    </li>

    <li v-if="$store.state.user?.is_superuser" class="nav-item px-3">
      <button class="btn btn-primary" type="button" @click=on_add_new>Dodaj</button>
    </li>
  </ul>

<table class="table">
  <thead>
    <tr>
      <th scope="col">Numer punktu</th>
      <th scope="col">Typ Statku powietrznego</th>
      <th scope="col">Specjalizacja</th>
      <th scope="col">System</th>
      <th scope="col">Agregat</th>
      <th scope="col">Tekst punktu</th>
      <th scope="col">karta technologiczna</th>
      <th scope="col">poziom obsług</th>
    </tr>
  </thead>
  <tbody>
    <tr v-for="jzot in jzot_list" :key="jzot.id">
      <th scope="row">{{jzot.point_number}}</th>
      <td>{{jzot.airship_type_serialized.name}}</td>
      <td>{{jzot.specialization_serialized.name}}</td>
      <td>{{jzot.system}}</td>
      <td>{{jzot.aggregate}}</td>
      <td>{{jzot.point_text}}</td>
      <td><a :href="jzot.technologic_card_url" >technologic_card </a></td>
      <td>{{jzot.handlings_level_serialized.level}} {{jzot.handlings_level_serialized.air_ship_type_serialized.name}}</td>
      <td>
        <div class="btn-group">
          <button class="btn btn-secondary" v-if="$store.state.user?.is_superuser" @click="EditJzot(jzot.id)">Edytuj</button>
          <button class="btn btn-secondary" v-if="$store.state.user?.is_superuser" @click="DeleteJzot(jzot.id)">Usuń</button>
        </div>
      </td>
    </tr>
  </tbody>
</table>


  </div>
</template>

<script>
import { setAuthorizationToken } from "../../utils/authUtils";
import { getJzot, getAirshipTypes, getSpecializations, deleteDataBaseObject, getJzotById } from "../../utils/apiUtils";
import router from "../../router";

const jzot_url = "http://127.0.0.1:8000/handlings/jzot/";

export default {
  // @TODO dodać belkę z wyszukiwaniem, po specjalności i po systemie i po typie statku powietrznego
  // @TODO dodać wszystkie informacje do tego widoku z rekordu Jzot, np. w tabelce (usunąć JsotRekord )
  name: "JzotBrowse",
  props: {
    id : String,
    on_edit : Function,
    on_add_new : Function
  },
  data: function() {
    return {
      jzot_list: [],
      airship_type_list: [],
      specialization_list: [],

      airship_type_selected_ids: new Set(),
      specialization_selected_ids: new Set()
    };
  },
  methods: {
    ApplyFilters() {
      (async () => {
          const params = {
            filters: {
              airship_type: JSON.stringify(Array.from(this.airship_type_selected_ids.values())),
              specialization: JSON.stringify(Array.from(this.specialization_selected_ids.values()))
            }
          }
          setAuthorizationToken(localStorage.getItem("jwtAccessToken"));
          this.jzot_list = await getJzot(params);
      })();
    },
    ClearFilters() {
      for (let spec of this.specialization_list) {
        spec.checkbox = false
      }
      for (let type of this.airship_type_list) {
        type.checkbox = false
      }

      this.airship_type_selected_ids.clear()
      this.specialization_selected_ids.clear()
    },
    SelectFilter(event, selected_set) {
      if (event.target.checked) {
        selected_set.add(parseInt(event.target.value, 10))
      } else {
        selected_set.delete(parseInt(event.target.value, 10))
      }
    },
    EditJzot(id) {
      this.on_edit?.(id);
    },
    DeleteJzot(id) {
      if (window.confirm("Are you sure ?")) {
        (async () => {
          try {
              setAuthorizationToken(localStorage.getItem("jwtAccessToken"));
              const response = await deleteDataBaseObject(jzot_url + id + "/");
              if (response.status === 204) {
                  window.alert("jzot deleted");
                  this.jzot_list = await getJzot();
                  this.ApplyFilters();
              }
          } catch (error) {
              window.alert("cannot delete this jzot");
          }
      })();
      }
    },
    async init() {
      setAuthorizationToken(localStorage.getItem("jwtAccessToken"));
      if (this.id) {
        this.jzot_list.push(await getJzotById(this.id));
        return;
      }

      this.jzot_list = await getJzot();
      this.airship_type_list = await getAirshipTypes();
      this.specialization_list = await getSpecializations();
    },
  },
  computed: {
    isAuthenticated: function() {
      return this.$store.state.isAuthenticated
    }
  },
  watch: {
    id() {
      (async () => {
        await this.init()
    })();
    }
  },
  mounted: function() {
    (async () => {
        await this.init()
    })();
  }
};
</script>

<style scoped>

/* @TODO do something with this styles!!! - make it global or something */
</style>>